#include <iostream>
#include "windows.h"

#define N 10000

int x[2 * N];
int n;

int odomknute = 1;

int vyber_xchg() {
	__asm {
	l1: mov eax, 0
		lock xchg odomknute, eax
		cmp eax, 1
		jne l1
	}
	int res = x[n];
	n++;
	odomknute = 1;
	return res;
}

int vyber_shr() {
	__asm {
	l1: shr odomknute, 1
		jnc l1
	}
	int res = x[n];
	n++;
	odomknute = 1;
	return res;
}

int vyber_zamykacie() {
	while (odomknute != 1);
	odomknute = 0;
	int res = x[n];
	n++;
	odomknute = 1;
	return res;
}

CRITICAL_SECTION cs;

int vyber_semafor() {
	EnterCriticalSection(&cs);
	int res = x[n];
	n++;
	LeaveCriticalSection(&cs);
	return res;
}

int vyber() {
	int res = x[n];
	n++;
	return res;
}

DWORD WINAPI MojThread (_In_ LPVOID lpParameter) {
	int *li = (int *)lpParameter;
	for (int i = 0; i < N; i++) {
		li[i] = vyber(); // <<< zmenou tohto riadku sa daju skusat jednotlive verzie funkcie vyber
	}
	return 0;
}

int li1[N];
int li2[N];

bool testuj(int li1[], int li2[], int n) {
	int i1, i2, narade;
	i1 = 0; i2 = 0; narade = 0;
	FILE* f;
	fopen_s(&f, "d:\\test.txt", "w");  // <--- tu zmente d: na ine podla vasho pocitaca
	bool ok = true;

	if (n != 2 * N) {
		fprintf(f, "nespravne n: %d\n", n); ok = false;
	}

	while (narade < 2 * N) {
		if (i1 < N && li1[i1] == narade)
			i1++;
		else if (i2 < N && li2[i2] == narade)
			i2++;
		else {
			fprintf(f, "chyba: %d\n", narade); ok = false;
		}

		while (i1 < N && li1[i1] == narade) {
			i1++; fprintf(f, "dvakrat: %d\n", narade); ok = false;
		}
		while (i2 < N && li2[i2] == narade) {
			i2++; fprintf(f, "dvakrat: %d\n", narade); ok = false;
		}
		narade++;
	}

	fclose(f);
	return ok;
}

int main() {
	HANDLE h[2];

	//SetProcessAffinityMask(GetCurrentProcess(), 1); // aby proces bezal len na prvom jadre (druhy parameter je bitova maska)

	//InitializeCriticalSection(&cs); // treba len pre pouzitie vyber_semafor

	for (int i = 0; i < 2 * N; i++)
		x[i] = i;
	n = 0;

	h[0] = CreateThread(NULL, 0, &MojThread, &li1, CREATE_SUSPENDED, NULL);
	h[1] = CreateThread(NULL, 0, &MojThread, &li2, CREATE_SUSPENDED, NULL);

	for (int i = 0; i < 2; i++) ResumeThread(h[i]);

	WaitForMultipleObjects(2, h, true, INFINITE);

	printf("--koniec\n");

	if (testuj(li1, li2, n))
		printf("OK\n");
	else
		printf("ZLE\n");

	return 0;
}