import threading
from time import time

class Data:    
    def __init__(self,pocet):
        self.x = [i for i in range(pocet)]
        self.n = 0
    def vyber(self,proces):
        res=self.x[self.n]
        self.n+=1
        return res

class Data_Peterson:
    def __init__(self,pocet):
        self.x = [i for i in range(pocet)]
        self.n = 0
        self.narade = 0
        self.zaujem = [False,False]

    def vstup_do_ks(self,proces):
        druhy = 1-proces
        self.zaujem[proces] = True
        self.narade = proces
        while self.narade == proces and self.zaujem[druhy]:
            pass

    def vystup_z_ks(self,proces):
        self.zaujem[proces] = False
        
    def vyber(self,proces):
        self.vstup_do_ks(proces)
        res=self.x[self.n]
        self.n+=1
        self.vystup_z_ks(proces) 
        return res

class Data_Semafor:
    def __init__(self,pocet):
        self.x = [i for i in range(pocet)]
        self.n = 0
        self.mutex = threading.Lock()

    def vyber(self,proces):
        with self.mutex:
            res=self.x[self.n]
            self.n+=1
        return res

def vyberaj(mojecislo,obj,kolko,li):
    for i in range(kolko):
        li.append(obj.vyber(mojecislo))

def skus_class(kolko,Data_class):
    ti = time()
    obj = Data_class(2*kolko) # vytvor data
    li1 = []
    li2 = []
    try:
        t1=threading.Thread(target=vyberaj, args=(0, obj, kolko, li1) )
        t2=threading.Thread(target=vyberaj, args=(1, obj, kolko, li2) )
        t1.start()
        t2.start()
    except:
        print("Chyba: nepodarilo sa spustit vlakna")
    t1.join()             # pockaj na skoncenie
    t2.join()
    print(time()-ti,'n=',obj.n) # kontrolny vypis - cas a n
    test(li1,li2,kolko)         # kontrola spravnosti oboch zoznamov - ci obsahuju kazde cislo prave raz

def test(li1,li2,kolko):
    s1=set(li1); s2=set(li2)            # prerobime zoznamy na mnoziny
    vsetky=set(range(2*kolko))          # mnozina vsetkych ocakavanych hodnot
    chybajuce=vsetky-s1-s2              # mnozina chybajucich prvkov 
    duplicitne=s1 & s2                  # mnozina duplicitnych prvkov
    if chybajuce | duplicitne:
        print("ZLE")
        if chybajuce:  # vypis pocet a najviac desat chybajucich prvkov
            print('chybaju',len(chybajuce),list(chybajuce)[:10])
        if duplicitne: # vypis pocet a najviac desat duplicitnych prvkov
            print('dvakrat',len(duplicitne),list(duplicitne)[:10])
    else:
        print("OK")
    
def skus(kolko):
    skus_class(kolko,Data)

def skus_p(kolko):
    skus_class(kolko,Data_Peterson)
    
def skus_s(kolko):
    skus_class(kolko,Data_Semafor)
    
