import threading

class Producent_konzument:
    def __init__(self,maxp,prod,konz):
        self.pole = []
        self.mutex = threading.Lock()
        self.prazdne = threading.Semaphore(value=maxp)
        self.plne = threading.Semaphore(value=0)
        self.produkuj = prod
        self.konzumuj = konz

    def producent(self,n):
        while True:
            prvok = self.produkuj()
            self.prazdne.acquire()
            with self.mutex:
                print('producent',n,'vklada',prvok)
                self.pole.append(prvok)
            self.plne.release()
            if prvok == None: break 

    def konzument(self,n):
        while True:
            self.plne.acquire()
            with self.mutex:
                prvok = self.pole.pop(0)
                print(' konzument',n,'vybera',prvok)
            self.prazdne.release()
            if prvok == None: break
            self.konzumuj(prvok)

class Producent_konzument_monitor:
    def __init__(self,maxp,prod,konz):
        self.pole = []
        self.maxp = maxp
        self.mutex = threading.Lock()
        self.vybralsom = threading.Condition(self.mutex)
        self.vlozilsom = threading.Condition(self.mutex)
        self.produkuj = prod
        self.konzumuj = konz

    def producent(self,n):
        while True:
            prvok = self.produkuj()
            with self.mutex:
                if len(self.pole) == self.maxp:
                    self.vybralsom.wait()
                print('producent',n,'vklada',prvok)
                self.pole.append(prvok)
                self.vlozilsom.notify()
            if prvok == None: break

    def konzument(self,n):
        while True:
            with self.mutex:
                if len(self.pole) == 0:
                    self.vlozilsom.wait()
                prvok = self.pole.pop(0)
                print(' konzument',n,'vybera',prvok)
                if len(self.pole) == self.maxp-1:
                    self.vybralsom.notify()
            if prvok == None: break
            self.konzumuj(prvok)

class Producent_konzument_monitor_opraveny:
    def __init__(self,maxp,prod,konz):
        self.pole = []
        self.maxp = maxp
        self.mutex = threading.Lock()
        self.vybralsom = threading.Condition(self.mutex)
        self.vlozilsom = threading.Condition(self.mutex)
        self.produkuj = prod
        self.konzumuj = konz

    def producent(self,n):
        while True:
            prvok = self.produkuj()
            with self.mutex:
                while len(self.pole) == self.maxp:
                    self.vybralsom.wait()
                print('producent',n,'vklada',prvok)
                self.pole.append(prvok)
                self.vlozilsom.notify()
            if prvok == None: break

    def konzument(self,n):
        while True:
            with self.mutex:
                while len(self.pole) == 0:
                    self.vlozilsom.wait()
                prvok = self.pole.pop(0)
                print(' konzument',n,'vybera',prvok)
                if len(self.pole) == self.maxp-1:
                    self.vybralsom.notify()
            if prvok == None: break
            self.konzumuj(prvok)

import time
import random

def konzumuj(x):
    time.sleep(random.randint(1,10)/100) #simulujeme cas konzumovania

# Implementuje zastavenie procesov po urcitom nahodnom case
#   tym, ze funkcia produkuj od isteho momentu vzdy vracia None
# mechanizmus zastavenia ale funguje len
#  ak je nie je konzumentov viac nez producentov a konzumentov nie je viac nez dlzka frontu

def produkuj():
    global wasNone
    time.sleep(random.randint(10,100)/100) #simulujeme cas produkovania
    if wasNone:
        return None
    if random.randint(1,30) == 1:
        wasNone = True
        return None
    else:
        return random.randint(1,100)

def producent_konzument_class(p,k,Class):
    global wasNone
    wasNone = False
    pk = Class(10,produkuj,konzumuj)
    t = []
    for i in range(p):
        t.append(threading.Thread(target=pk.producent,args=(i,)))
    for i in range(k):
        t.append(threading.Thread(target=pk.konzument,args=(i,)))
    for tr in t:
        tr.start()
    for tr in t:
        tr.join()

def pk(p,k):
    producent_konzument_class(p,k,Producent_konzument)

def pk_m(p,k):
    producent_konzument_class(p,k,Producent_konzument_monitor)
    
def pk_m2(p,k):
    producent_konzument_class(p,k,Producent_konzument_monitor_opraveny)
