import threading
import time
import random
    
def filozof(i):
    while True:
        rozmyslaj()
        zober(i)
        zober((i+1)%5)
        jedz()
        pusti(i)
        pusti((i+1)%5)


class Filozof(threading.Thread):

    zijeme = True
    
    def __init__(self, meno, mutex):
        threading.Thread.__init__(self)
        self.meno = meno
        self.mutex = mutex
        self.mozem = threading.Lock()
        self.mozem.acquire()            ## musi zacinat na 0
        self.stav = "rozmysla"

    def nastav_susedov(self,lavy,pravy):
        self.susedL = lavy
        self.susedP = pravy

    def run(self):
        while self.zijeme:
            self.rozmyslaj()
            self.zober()
            self.jedz()
            self.pusti()

    def zober(self):
        with self.mutex:
            self.stav = "hladny"
            self.test()
        self.mozem.acquire()

    def pusti(self):
        with self.mutex:
            self.stav = "rozmysla"
            self.susedL.test()
            self.susedP.test()

    def test(self):
        if self.stav == "hladny" and \
          self.susedL.stav != "je" and \
          self.susedP.stav != "je":
            self.stav = "je"
            self.mozem.release()

    def rozmyslaj(self):
        print('{} rozmysla\n'.format(self.meno),end = "")
        time.sleep(random.uniform(3,13))
        print('{} je hladny\n'.format(self.meno),end = "")

    def jedz(self):
        print('{} zacina jest\n'.format(self.meno),end = "")
        time.sleep(random.uniform(1,10))
        print('{} dojedol\n'.format(self.meno),end = "")

def filozofuj():
    mutex = threading.Lock()
    mena = ('Aristoteles','Kant','Buddha','Marx', 'Russel')
 
    f = [Filozof(mena[i], mutex) for i in range(5)]
    for i in range(5): f[i].nastav_susedov(f[(i-1)%5],f[(i+1)%5])
 
    Filozof.zijeme = True
    for p in f: p.start()
    time.sleep(100)
    Filozof.zijeme = False
    for p in f: p.join()
            
            
class CitanieZapis:

    def __init__(self):
        self.mutex = threading.Lock()
        self.databaza = threading.Lock()
        self.citaju = 0

    def pisatel_vojdi(self):
        self.databaza.acquire()

    def pisatel_vyjdi(self):
        self.databaza.release()

    def citatel_vojdi(self):
        with self.mutex:
            self.citaju += 1
            if self.citaju == 1:
                self.databaza.acquire()

    def citatel_vyjdi(self):
        with self.mutex:
            citaju -= 1
            if citaju == 0:
                self.databaza.release()
                
def pisatel(cz):
    while True:
        vytvor_udaje()
        cz.pisatel_vojdi()
        try:
            zapis_udaje()
        finally:
            cz.pisatel_vyjdi()

def citatel(cz):
    while True:
        cz.citatel_vojdi()
        try:
            citaj_udaje()
        finally:
            cz.citatel_vyjdi()
        spracuj_data()

class SpiaciHolic:

    def __init__(self,stoliciek):
        self.stoliciek = stoliciek
        self.zakaznici = threading.Semaphore(value=0)
        self.holici = threading.Semaphore(value=0)
        self.mutex = threading.Lock()
        self.cakajuci = 0
        
    def ber_zakaznika(self):
        self.zakaznici.acquire()
        with self.mutex:
            self.cakajuci -= 1
            self.holici.release()

    def cakaj_holica(self):
        self.mutex.acquire()
        if self.cakajuci < self.stoliciek:
            self.cakajuci += 1
            self.zakaznici.release()
            self.mutex.release()
            self.holici.acquire()
            return True
        else:
            self.mutex.release()
            return False

sh = SpiaciHolic(5)

def holic():
    while True:
        sh.ber_zakaznika()
        strihaj_zakaznika()

def zakaznik():
    while True:
        if sh.cakaj_holica():
            daj_sa_strihat();

